<template>
    <div class="investors-filter">
        <base-filter :params="filterParams"
            v-model="filterData"
            :pickerOptions="pickerOptions"
            @apply="initFilter"
            @reset="resetFilter"
        />
    </div>
</template>

<script>
import { expertsFilterSettings, defaultExpertsFilter } from '@/constants/ui/filters';
import { mapState } from 'vuex';
import filterMixin from '@/mixins/filterMixin';
import BaseFilter from './baseFilter';

export default {
    name: 'expertsFilter',
    components: {
        BaseFilter,
    },
    mixins: [filterMixin],
    data() {
        return {
            filterSettings: expertsFilterSettings,
            filterData: defaultExpertsFilter,
        };
    },
    computed: {
        ...mapState('experts', {
            serverFilter: state => state.filter,
        }),
    },
    methods: {
        /** Apply new expert filter params */
        initFilter() {
            this.$store.dispatch('experts/filterExpertsList', this.filterData);
        },
        /** Reset current expert filter params */
        resetFilter() {
            this.filterData = { ...defaultExpertsFilter };
            this.$store.commit('experts/clearExpertsFilter');
        },
    },
};
</script>
